module shp_triplet_open_m

  implicit none

contains

  subroutine shp_triplet_open(hshp, shp_triplet_dir, rank)

    ! Libraries:
    use shapelib_03, only: shp_open_03

    use derived_types, only: shp_triplet
    use read_field_indices_m, only: read_field_indices

    TYPE(shp_triplet), intent(out):: hshp
    character(len = *), intent(in):: shp_triplet_dir
    integer, intent(in):: rank

    !--------------------------------------------------------------------

    call shp_open_03(hshp%extremum, shp_triplet_dir // "/extremum", &
         pszaccess = "rb")
    call shp_open_03(hshp%outermost, shp_triplet_dir // "/outermost_contour", &
         pszaccess = "rb")
    call shp_open_03(hshp%max_speed, shp_triplet_dir // "/max_speed_contour", &
         pszaccess = "rb")
    call read_field_indices(hshp, rank)

  end subroutine shp_triplet_open

end module shp_triplet_open_m
